Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module FAD24

    '
    ' Device status (Return value)
    '
    Public Const FAD24_OK As Integer = 0
    Public Const FAD24_INVALID_HANDLE As Integer = 1
    Public Const FAD24_DEVICE_NOT_FOUND As Integer = 2
    Public Const FAD24_DEVICE_NOT_OPENED As Integer = 3
    Public Const FAD24_OTHER_ERROR As Integer = 4
    Public Const FAD24_COMMUNICATION_ERROR As Integer = 5
    Public Const FAD24_INVALID_PARAMETER As Integer = 6

    '
    ' Sampling Rate
    '
    Public Const FAD24_SAMPLING_RATE_50KSPS As Integer = 1
    Public Const FAD24_SAMPLING_RATE_25KSPS As Integer = 2
    Public Const FAD24_SAMPLING_RATE_10KSPS As Integer = 5
    Public Const FAD24_SAMPLING_RATE_5KSPS As Integer = 10
    Public Const FAD24_SAMPLING_RATE_2_5KSPS As Integer = 20
    Public Const FAD24_SAMPLING_RATE_1KSPS As Integer = 50
    Public Const FAD24_SAMPLING_RATE_500SPS As Integer = 100
    Public Const FAD24_SAMPLING_RATE_250SPS As Integer = 200
    Public Const FAD24_SAMPLING_RATE_100SPS As Integer = 500
    Public Const FAD24_SAMPLING_RATE_50SPS As Integer = 1000
    Public Const FAD24_SAMPLING_RATE_25SPS As Integer = 2000
    Public Const FAD24_SAMPLING_RATE_10SPS As Integer = 5000
    Public Const FAD24_SAMPLING_RATE_5SPS As Integer = 10000
    Public Const FAD24_SAMPLING_RATE_2_5SPS As Integer = 20000
    Public Const FAD24_SAMPLING_RATE_1SPS As Integer = 50000

    '
    ' Sampling Edge
    '
    Public Const FAD24_SAMPLING_EDGE_ON As Byte = 0
    Public Const FAD24_SAMPLING_EDGE_OFF As Byte = 1

    '
    ' Trigger Type
    '
    Public Const FAD24_TRIGGER_TYPE_NONE As Byte = 0
    Public Const FAD24_TRIGGER_TYPE_LEVEL_H As Byte = 1
    Public Const FAD24_TRIGGER_TYPE_LEVEL_L As Byte = 2
    Public Const FAD24_TRIGGER_TYPE_SLOPE_RISING As Byte = 3
    Public Const FAD24_TRIGGER_TYPE_SLOPE_FALLING As Byte = 4
    Public Const FAD24_TRIGGER_TYPE_EDGE_ON As Byte = 5
    Public Const FAD24_TRIGGER_TYPE_EDGE_OFF As Byte = 6


    '
    ' Device Functions
    '
    Public Declare Function FAD24_GetNumberOfDevices Lib "FAD24.dll" (ByRef Number As Integer) As Integer
    Public Declare Function FAD24_GetSerialNumber Lib "FAD24.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function FAD24_Open Lib "FAD24.dll" (ByRef ID As Byte) As Integer
    Public Declare Function FAD24_OpenBySerialNumber Lib "FAD24.dll" (ByVal SerialNumber As Integer, ByRef ID As Byte) As Integer
    Public Declare Function FAD24_Close Lib "FAD24.dll" (ByVal ID As Byte) As Integer

    '
    ' A/D Functions
    '
    Public Declare Function FAD24_Acquisition Lib "FAD24.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal Value As Object, ByVal SamplingRate As Integer, ByVal SamplingCount As Integer, ByVal TriggerType As Byte, ByVal TriggerThreshold As Double, ByVal TriggerWaitCount As Integer, ByRef AcquisitionCount As Integer) As Integer
    Public Declare Function FAD24_AcquisitionExt Lib "FAD24.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal Value As Object, ByVal SamplingEdge As Byte, ByVal SamplingCount As Integer, ByVal SamplingEdgeWaitCount As Integer, ByVal TriggerType As Byte, ByVal TriggerThreshold As Double, ByVal TriggerWaitCount As Integer, ByRef AcquisitionCount As Integer) As Integer
    Public Declare Function FAD24_AcquisitionSingle Lib "FAD24.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal Value As Object) As Integer

End Module
